Introduction

CloneSpy

This is the CloneSpy help file.

Introduction

CloneSpy is a very powerful tool, but incorrect usage may have very damaging effects on your system. Therefore, please read at least the following subsections of the introduction if you are using CloneSpy for the first time:
  • Overview
  • Important Note
  • Quick Start


Overview

Why was CloneSpy written?

Do you often download files from the Internet? Is your hard drive crowded with these files? Have you ever asked yourself which files you have downloaded more than once? Perhaps you have burned files to a CD and retrieved them again? Do you want to find these files and eliminate the duplicates? Maybe you want to find duplicate files without checking your entire collection of backup CDs every time? Then CloneSpy is the right tool for you!

What can CloneSpy do?

CloneSpy can help you free up hard drive space by detecting and removing duplicate files. Duplicate files have exactly the same contents regardless of their name, date, time and location. Also, CloneSpy is able to find files that are not exactly identical, but have the same file name. Perhaps you have different versions of a file and you want to find all of them and remove the older versions. CloneSpy can also find zero length files. These are files that have no content.

With CloneSpy you can process files which
  • are duplicates
  • are duplicates and have the same file name
  • have the same file name
  • have the same file name and (approximately) the same size
  • are zero bytes long
CloneSpy offers you a complete mechanism for determining which duplicate or same-name files should be removed. It is also possible to leave this decision up to the individual user.

CloneSpy can handle equal files by
  • deleting redundant files
  • moving redundant files to a specific folder
  • exporting a list of all equal files without removing any files
  • deferring file operations on redundant files to a batch file where you can apply arbitrary file operations
With CloneSpy you can build checksum files from files on CDs (or even on hard drives, etc.) and use them to check whether these files already exist on your system. The checksum files will prevent you from having to play DJ every time you search for duplicates!

If you are using CloneSpy for the first time, please take the time to read the Important Note and the Quick Start section.


Important Note

CloneSpy builds a list of all files in the selected drives and folders. For this reason, it is important that you do not run any applications which alter the files being searched for duplicates. This includes such operations as saving or deleting files, deleting whole directories or folders, and defragmenting drives. Doing this is not dangerous, but CloneSpy may display files which were duplicates at the time they were analyzed, but which have changed since. Use CloneSpy in the same way that you would use any defragmenting program. It is also recommended that you disable any virus scanner before running the program.


Quick Start

Make sure that you read the Important Note before using CloneSpy.

If you just want to find identical files in some of your drives or folders, follow these instructions:
  1. Press the Add folder button in the Pool 1 frame on the Main window. The Add folder window appears.

  2. Choose the drive or folder you want to recursively search for duplicates from the folder tree on the left side of the Add folder window and press the Add selected folder button. Repeat this until all folders you want to scan are inserted to the pool. Finally press the OK button.

  3. Back on the main window, leave the mode in the Mode frame set to Pool 1 only.

  4. Make sure, that the radio button Duplicates is pressed in the Search for frame.

  5. Check if the option Ask user is activated in the Action frame.

  6. Finally, press the button Start scanning in the lower right corner of the Main window. CloneSpy will start scanning all the drives and folders which were added to Pool 1. If CloneSpy finds duplicate files, these files will be displayed. Then, you can decide which file (if any) should be deleted. Deletion takes place immediately.
Warning!

  • If you choose the option Automatically delete in the Action frame CloneSpy will automatically delete files without any further confirmation.

  • Run the scanning process only on drives or folders where you are both aware of the contents and confident that it is safe to allow files to be deleted.

  • Be especially careful about scanning system folders! Over-zealous use could have very damaging effects.

  • Never use CloneSpy to scan the Windows folder or the whole drive where Windows is installed with automatic deletion. This will kill your system because there are certain files with the same content which Windows does not regard as redundant duplicates.

  • Hardlinks (NTFS specific) are not supported. Therefore, CloneSpy will handle hardlinks like normal files. Be careful!
For more details about configuring CloneSpy consult the description of the Main window and the description of the Options window.


Basics and Requirements

This section describes some basics about CloneSpy. Please refer to the following topics:
  • System Requirements
  • Warranty
  • Support
  • History


System Requirements

The 32-bit version of CloneSpy will run under Windows 98se, ME, NT 4.0, 2000 and XP.

CloneSpy requires a minimal screen resolution of 800 x 600 when using normal font size. If you use a larger print, you may need a higher resolution.

How much memory CloneSpy will use will depend on how many files are scanned. If you scan 100,000 files CloneSpy will require about 25 Mb of memory.


Warranty

Disclaimer of Warranty

If you do not agree to all of the terms of this agreement, you are not allowed to use the program CloneSpy.
  1. You agree not to reverse engineer, decompile, disassemble, alter, distribute for profit, or rent the software.

  2. The software is provided on an "AS IS" basis without warranties as to performance of merchantability or any other warranties whether expressed or implied. In particular, there is no warranty for the optional undelete feature provided by the Windows recycle bin. Because some software disables this feature, no warranty of fitness for a particular purpose is offered. You expressly agree that the use of the software is at your own risk.

  3. In no event will the author be liable to any party:

    1. For any direct, indirect, special, punitive, incidental or consequential damages (including, but not limited to, damages for loss of business profits, business interruption, loss of programs or information, and the like), or any other damages arising in any way out of the use of, reliance on, or inability to use the program even if the author shall have been advised of the possibility of such damages.

    2. For any claim attributable to errors, omissions, or other inaccuracies in, or destructive properties of any information. The author reserves the right not to be responsible for the correctness, completeness or quality of the software provided. Liability claims regarding damage caused by the use of CloneSpy will therefore be rejected.

  4. All copyrights of the software stay with the author.


Support

If you have problems using CloneSpy and are inclined to contact us, please do the following first:
  • Check that you are doing everything correctly. Everybody makes mistakes sometimes, especially if a program is rather complex.

  • Have a look at the help file. It may already contain the answer to your question. We are often asked for some specific explanation in relation to a question which is in fact fully documented in the help file.

  • Visit our web site on the Internet at www.clonespy.com. It is possible that you may find a newer version of CloneSpy there, which may resolve the issue for you. You can also find an FAQ section there which may help to answer your question.
If you still have problems using CloneSpy please contact technical support at

  technical@clonespy.com

Please have the following information to hand:
  • Your version of CloneSpy (see the About box)

  • Your windows version (including service packs and other fixes installed)

  • Information about your computer system (CPU type and speed, installed memory)

  • The description of your problem (please be as detailed as possible)
Moreover, any bug reports, suggestions, or other hints for improvement are welcome. Likewise any typos or bad English in this help file.

If you like CloneSpy and want to support our work with a small donation, please have a look at the Donation section at www.clonespy.com.

Marcus Kleinehagenbrock, the author.


History

06.06.2004 - Release of Version 2.11

  • Fixed: The program now does not crash any more when exporting a list or a batch file while searching for files with same name or with same name + (approx.) same size

09.05.2004 - Release of Version 2.1

  • Added: The Add folder window now allows to enter folder paths manually
  • Added: The scanning process can now be started automatically by Command line parameters. The program can also be exited automatically this way
  • Added: The priority of the scanning process can now be changed in the Scanning priority frame (see the new Priority tab of the Options window)
  • Added: Besides deleting files on shorter/longer file name, this decision can now be made according to their full path or directory path (see the Action frame in the Main window, the Single duplicates window, and the All duplicates window)
  • Added: CloneSpy can now be exited without automatically saving the settings if this is chosen in the Automation window (see the Menu bar of the Main window)
  • Added: All batch files generated by CloneSpy now present a warning when being executed
  • Fixed: All pools now offer a horizontal scroll bar if necessary
  • Fixed: The scanning process can now also be paused while it acquires CSC-files
  • Fixed: The scanning process now runs at normal speed while it acquires CSC-files
  • Fixed: The location of CSC-files is now remembered correctly if multiple files are added to the CSC-pool simultaneously

28.12.2003 - Release of Version 2.0

Complete re-implementation of CloneSpy in order to integrate a wide variety of new features:
  • Exclude files or file patterns from a scan
  • Case sensitive file name comparisons
  • Advanced log file options
  • Presentation of all duplicates at the end of a scan
  • Presentation of duplicates together in one large list
  • Lockable pools for faster scans if the content of a pool is used more than once
  • Search for same-name files with same size or approximately same size
  • File deletion decision based on length of file names
  • Export duplicates as list to a text file
  • Defer handling of duplicate files to a batch file in order to apply arbitrary file operations

Release dates of former versions:
  • 30.03.2002 - Release of Version 1.51
  • 24.03.2002 - Release of Version 1.5
  • 28.12.2001 - Release of Version 1.41
  • 16.12.2001 - Release of Version 1.4
  • 02.09.2001 - Release of Version 1.3
  • 28.07.2001 - Release of Version 1.2
  • 09.07.2001 - Release of Version 1.11
  • 08.07.2001 - Release of Version 1.1
  • 24.06.2001 - Release of Version 1.0
More information on former versions can be found in the history section at www.clonespy.com.


Using CloneSpy

In order to learn how to use CloneSpy please refer to the following topics and descriptions of the program's individual windows, respectively:
  • the Command line parameters
  • the Main window
  • the Add folder window
  • the Options window
  • the Insert mask window
  • the Automation window
  • the View CSC-file window
  • the Result presentation windows


Command line parameters

The usage of CloneSpy is:

  CloneSpy [-a [<settings file>] [-e]]

-a

If you call CloneSpy with this parameter then the scanning process will be started right after the program's window appears. To make use of this option, CloneSpy should be configured to automatically read a settings file when it starts. Otherwise the scanning process cannot be launched. In order to load a settings file when the program starts please have a look at the Automation window.

-a <settings file>

This way CloneSpy will also perform an autostart like in the -a case above. But if you provide a settings file, the program does not need to be configured to automatically load a settings file when it starts. Moreover, if this is enabled in the Automation window then the selection of the settings file will be overridden by the file specified in the command line. Important to mention is that a file path must be quoted if it contains free space characters, like in the following example:

  CloneSpy -a "C:\Program files\CloneSpy\Default.cst"

Note: If a settings file is specified in the command line then the settings are not automatically saved on program exit to the file specified in the Automation window, even if this option is activated. This procedure prevents CloneSpy from accidentally overwriting the standard settings file by the settings file given in the command line. If you want to save the settings even though, you have to do it manually (see the menu of the Main window).

-e

This parameter can only be used in combination with the -a parameter. It makes CloneSpy to close itself when the automatically started scan is finished. This option is intended to be used if either duplicates are processed automatically or the result of the scan is exported (see the Action frame in the Main window). To ensure unattended operation of the program in this case, errors should be suppressed (see the Ignore errors frame in the Report tab in the Options window).


The Main window

The Main window contains the following:
  • A menu bar
  • Several window elements


The menu bar

The menu bar of the Main window consists of the File menu, the Update menu, and the Help menu. While the Help menu is self-explanatory, some of the File menu items may need some explanation. The items of the Update menu are explained thereafter.

The File menu consists of the following items:
  • Options: Selecting this menu item opens the Options window.

  • Settings: This menu item includes a sub-menu with four components:

    • Load Settings: All settings on the Main window and on the Options window can be loaded from a CloneSpy settings file (*.cst). See below on how to create a CloneSpy settings file.

    • Save Settings: All settings entered in the Main window and in the Options window will be saved to a specified file. When you click on this menu item, a dialog box appears that allows you to specify the name of the CloneSpy settings file (*.cst). Your selected settings will be saved in this file. You can create different setting profiles for CloneSpy.

    • Automation: If you click on this menu item the Automation window is displayed. In this window you can specify if a settings file should be loaded when the program starts and if all settings should be saved on program exit.

    • Reset To Defaults: This menu item resets all settings entered in the Main window and in the Options window to the default settings. These are the settings that were in effect when the program was started.

  • View CSC-file: This item is for viewing a specified a CSC-file. Please refer to the View CSC-file window for further information.

  • Exit w/o Save: Quit CloneSpy without automatically saving the settings to the file specified in the Automation window. This item is only available if the corresponding option in the Automation window is activated.

  • Exit: Quit CloneSpy.
The Update menu contains only two items:
  • Check For New Version: If you select this item, CloneSpy tries to check out if there is a new version available on the Internet. Before selecting this option, make sure that your computer is connected to the Internet. If the check is successful, CloneSpy will report whether there is a new version available or not. If an error occurs, although a connection to the Internet has been established, the Internet may be busy or the corresponding web site may be down.

  • Check Automatically: This item toggles the option to either check for new updates automatically or not. If you check this item, no update check is performed. CloneSpy only looks out for a new version on program start and this is done at most once a day. If CloneSpy was able to successfully perform an update check it will only report if a new version is available. This option is disabled by default.
Note: The Internet update function does not transmit any information about your system.


The window elements

The Main window includes several controls which are grouped together in the following seven frames:
  • the Pool frames
  • the Checksum files frame
  • the Mode frame
  • the Search for frame
  • the Action frame
  • the On automatic deletion frame
  • the Some scanning properties frame


The Pool frames

The Main window offers two pool frames: Pool 1 and Pool 2. Here, you specify the drives and folders to be recursively searched for files that are e.g. identical or have the same name. See the Search for frame for corresponding settings.

For an explanation of why there are two pools, please have a look at the Mode frame.

The button Clear list removes all drives and folders from the list box. When you select Add folder the Add folder window appears in order to let you add drives and folders to the list box.

You have the option of either scanning the specified drives and folders right away by starting the scanning process, or creating a CloneSpy checksum file. If you select Make CSC, a dialog box opens and you can specify the file name for the output checksum file. This checksum file will contain all necessary data for the files found in the corresponding pool (including a specific 256 bit checksum), having regard to all restrictions entered in the Options window. Checksum files allow you to compare them to other files on your hard drive at a later point in time. This is quite useful if you want to compare files on your hard drive to files you have stored on a backup CD. This way you don't need to keep scanning your backup CDs again and again - you just store the corresponding checksum files once on your hard drive. The size of a checksum file depends on the number of files you load in the pool. Of course, if you let CloneSpy compare a checksum file to files on your hard drive, you will only be able to delete files on your hard drive.

The Lock pool button is disabled at the beginning. After scanning a pool for the first time, the color of the pool items will change from black to green. In addition, the Lock pool button is enabled. This shows that checksums generated in the scan just completed may be used again for the next scan. This may result in faster processing. In order to reuse the data stored in a pool, press the Lock pool button. The appearance of the button will change from

to

The corresponding pool will not be acquired again, but it may be necessary for additional checksums to be generated. Press the button a second time to unlock the pool again.

Assume, that a pool is lockable (i.e. the Lock pool button is enabled). If you now change some settings in the Options window, the color of the pool will change back from green to black, because different restrictions may result in the acquisition of different files. But, if you lock the pool before changing the options, the changes do not affect the content of the pool. For example, you may lock Pool 1 after scanning it, change the options in order to acquire files in Pool 2 with different settings, and scan it against Pool 1.

Caution!

Be careful what you enter in the pools. Add only drives and folders which contain data which you understand and would be happy to delete. Because all folders are scanned recursively, it is most important that you do not enter the entire drive where your Windows system is installed.


The Checksum files frame

The Checksum file frame is used to import previously generated CloneSpy checksum files. The data of a checksum file can be compared to files on your hard drives. Please refer to the Pool frames on how to generate a checksum file.

The button Clear list will remove all checksum files added to the list box. If you select the Add CSC-file button, a dialog box appears and allows you to choose one or more checksum files. The selected file(s) will be added to the list box.

If you want to view a CSC-file, double click on it after inserting it in the list box or press the View CSC button. Another way of viewing a CSC-file is to select the item View CSC-File in the file menu of the Main window. How the contents of the selected CloneSpy checksum file are displayed is explained in the description of the View CSC-file window.

If you want to compare checksum files to files on your hard drives, you have to choose one of the last two options in the Mode frame. Drives and folders you want to scan have to be added to the pool in the corresponding Pool frame. Deletion of files will only be possible if the files originate from Pool 1 or Pool 2, respectively, but not if they come from the CSC-file.


The Mode frame

This frame is for selecting which pools are used for a scan. It offers five options:
  1. Only Pool 1: CloneSpy will process only those files that belong to a drive or folder added to Pool 1. All of these files which pass the restrictions made in the Options window will be checked against each other.

  2. Only Pool 2: Same as above, but with Pool 2.

  3. Both Pools: CloneSpy will compare the files that belong to a drive or folder in Pool 1 to the files that belong to a drive or folder in Pool 2. The files in Pool 1 will not be checked against each other, just as the files in Pool 2 will not be checked against each other. This option is handy if you have already checked your system for duplicates, but subsequently add a folder of new files. You can insert the new folder in Pool 1, and all the other folders you want to check in Pool 2.

  4. Pool 1 + CSC: CloneSpy will compare the files in drives and folders contained in Pool 1 to the file data stored in the checksum files inserted to the Checksum files frame.

  5. Pool 2 + CSC: Same as above, but with Pool 2.
Note: Remember that all acquired files are checked against all restrictions defined in the Options window. This may mean that the number of files scanned will be less than the actual number of files residing in folders or on the drives added to the scanned pool.


The Search for frame

This frame allows you to select one of the following four modes:
  1. Duplicates: CloneSpy will search for files that have exactly the same content. In this case the files will be the same size but will not necessarily have the same date or time stamp.

  2. Duplicates + same name: CloneSpy will search for files that have the same name and the same content, but not necessarily the same date or time. The comparison of file names is not case sensitive by default, but can be changed in the Comparison of file names frame in the Options window.

  3. Same name: CloneSpy will search for files that have the same name. As in option 2 the comparison of file names is either case insensitive or case sensitive as determined by the Comparison of file names frame in the Options window. The files will not necessarily have the same content, size, date or time.

  4. Same name + (approx.) same size: This option is the same as 3 but the size of the compared files must be equal or at least similar to each other. The maximum allowed difference between the sizes of the compared files can be defined in the Size of same-name files frame.


The Action frame

The Action frame contains three main selections:
  1. Automatically delete (without confirmation): If this option is selected, CloneSpy will automatically delete all redundant files. Therefore, this option offers up to eight possible sub selections in order to specify which files are redundant for the user and should be deleted. Depending on the selections made in the Mode frame or in the Search for frame, some selections may be unavailable. The term equal files in the following list refers to the selection made in the Search for frame.

    1. only in Pool 1: This option will only be available if you chose the Both pools option or the Pool 1 + CSC option in the Mode frame. If CloneSpy finds equal files there will be at least one file in Pool 1 and at least one file in Pool 2 or in the CSC-file respectively. CloneSpy will delete the file located on a drive or in a folder in Pool 1.

    2. only in Pool 2: Same as above, but with Pool 2.

    3. older files: If CloneSpy finds equal files, only the newest one will be retained. The term older refers to the last modification date and time. This option is not available if CSC-files are scanned.

    4. newer files: Same as above, but CloneSpy will retain the oldest file.

    5. smaller files: If equal files are found, CloneSpy will retain the largest file. This means that only the file with the highest number of bytes will be retained. This option is not available while searching for duplicates, since identical files will always be the same size. In addition, this option is not available if CSC-files are scanned. If you want to search for same-name files with approximately the same size this selection is only available if the allowed difference entered in the Size if same-name files frame is larger than zero bytes.

    6. larger files: Same as above, but CloneSpy will retain the smallest file.

    7. files with shorter file name/full path/dir path: If CloneSpy finds equal files, only the file with the longest file name/full path/directory path will be retained. The meaning of the terms that can be selected from the drop down list can be seen in the following file path example:

        C:\Store\ImportantData\AllData.txt
        \____________________/ \_________/
            directory path      file name
        \________________________________/
                    full path

      One of these selections can only be activated if you want to search for simple duplicates.

    8. files with longer file name/full path/dir path: The same as above, but CloneSpy will retain the file with the shortest file name/full path/directory path.

  2. Export a list of all equal files: If selected, CloneSpy will export a list of all equal files instead of removing any file. The format of the list file can be defined in the Export list properties frame in the Options window.

  3. Ask user: If CloneSpy detects equal files, a dialog is displayed and the user is asked to select which files should be deleted. When and how equal files are presented to the user can be selected in the Presentation of equal files frame in the Options window. For more information about the presentation itself see the Result presentation windows.


The On automatic deletion frame

This frame will only be active if you select the option Automatically delete in the Action frame.

The frame offers two options:
  1. Delete directly: Duplicate files will be processed as indicated in the How to delete frame in the Options window.

  2. Defer deletion to batch file: No operation is actually executed on duplicate files. Instead, information about these files is written to a batch file as defined in Batch file properties frame. Therefore, this option not only allows you to batch targeted files for deletion but also to apply arbitrary file operations to them.


The Some scanning properties frame

This frame informs you about some special settings selected in the Options window. These settings are highlighted here, because they may affect the selections made in the Main window or the way duplicate files are handled.

If the items in this frame are grayed they are not active. If they are black they are active and have the following meaning:
  • Delete read-only files: In the Deletion of read-only files frame you are choosing to ignore the read-only protection. Therefore CloneSpy may remove read-only protected files without any further confirmation.

  • Really delete files: You have chosen in the How to delete frame to delete files irrecoverably. This means that if files are deleted they will not be moved to the recycle bin. So, it will be impossible to restore deleted files after a scan.

  • Create shortcuts: In the Shortcuts frame you have chosen to replace each deleted file with a shortcut to a corresponding retaining file.

  • Override delete selection: You have chosen in the Override delete selection frame to allow CloneSpy to revise an automatic delete selection made in the Action frame based on the names of the files.

  • Compare case sensitive: You have chosen in the Comparison of file names frame to make case sensitive file name comparisons. Therefore, CloneSpy will differentiate between upper case and lower case characters.

  • Delete zero length files: In the Zero length files frame you have chosen to delete a scanned files if it is zero bytes long.
Press the Start scanning button to start the scanning process which will reflect all settings made in the Main window and in the Options window.


The Add folder window

This window is for adding folders to either Pool 1 or Pool 2. It appears after clicking on the corresponding Add folder button in one of the Pool frames in the Main window.

The window elements

The window is subdivided in three different frames: the Folder tree frame on the left hand side, the Manual input frame on the upper right hand side, and the Pool frame in the middle of the right hand side.

The Folder tree frame

At the top of this frame a tree view control shows the directory tree of your computer. In order to add a folder to the folder list of the Pool frame select the folder from the directory tree by clicking on it. Then, click the button Add selected folder which can be found directly below the tree view control and the folder will appear in the pool of the Pool frame.

If you press the button Add all sibling folders instead of the Add selected folder button, not only the selected folder, but all folders that are in the same folder as the selected folder are added to the folder list of the Pool frame.

The Manual input frame

This frame contains an edit box at its top. Here you can enter a folder path manually, e.g., by using the clipboard with copy and paste. By pressing the button Add folder below the edit box, the folder entered to the edit box will be added to the pool of the Pool frame. If the specified folder is invalid, i.e., it does not exist, it will not be added to the folder list of the Pool frame.

The Pool frame

This frame contains the corresponding pool. In order to add a folder to it either select the folder in the Folder tree frame or specify the folder manually in the Manual input frame.

Pressing the Clear Pool button will remove all folders from the pool. If you want to remove a single folder, select it and press the Del key on your keyboard.

If you double click an element in the pool on the right side, the corresponding folder will be selected in the tree view control in the Folder tree frame.

Note: It is not possible to have the same folder in both of the pools in the Main window. Therefore, if you add a folder to a pool while it is already in the other pool, it will be removed from the first pool.


The Options window

If you click on the options menu item in the file menu of the Main window, a new window will be opened. This window will present you with several additional options in a tab control. The tab control items are:
  • the Attributes tab
  • the Deletion tab
  • the Files tab
  • the Folders tab
  • the Names tab
  • the Time + Size tab
  • the Logging tab
  • the Report tab
  • the Export tab
  • the Priority tab


The Attributes tab

In this tab options which deal with file attributes of scanned files are presented in two frames:
  • the File attributes of scanned files frame
  • the Deletion of read-only files frame


The File attributes of scanned files frame

This frame allows you to restrict a scan to files which have specific file attributes.

The columns of the presented table refer to the file attributes Read-only, Hidden, System, and Archive, respectively. The rows of the table define whether the corresponding file attribute Must be set, Must not be set, or can be ignored at all (Ignore attribute).

Using the default settings as presented in the image above files are scanned only if they are neither Hidden nor System files. The Read-only and Archive attributes are not considered.


The Deletion of read-only files frame

In this frame you can decide how read-only files should be handled, if CloneSpy selects them for deletion.

The first option forces CloneSpy to present a confirmation window every time it wants to delete a read-only file. In this window you can either choose to allow or to skip the deletion of the corresponding read-only file.

If you set the second option, CloneSpy will ignore the read-only attribute and delete a selected file even if it is write protected.

The last option prevents CloneSpy from deleting read-only files at all. Note that with this option, if you also selected the Automatically delete option in the Action frame in the Main window, duplicates may remain on your system. If you allow CloneSpy to ask you which files should be deleted (the Ask user option in the Action frame), a confirmation window will be displayed nevertheless.

Note: This frame is inactive if you set the Read-only option in the File attributes of scanned files frame to Must not be set. This is because no read-only files are acquired in that mode.


The Deletion tab

This tab groups together all options which define how files are deleted or handled, respectively. Altogether there are four frames:
  • the How to delete frame
  • the Move to folder frame
  • the Deletion of folders frame
  • the Shortcuts frame


The How to delete frame

In this frame you can select in which way CloneSpy will handle a targeted file according to the selection made in the Action frame in the Main window. The options are:
  • Delete to recycle bin: All files that are to be deleted are moved to the recycle bin.

  • Really delete: Files are actually removed from the system and therefore they will not appear in the recycle bin.

  • Move to folder: This selection gives you the option to move files to a specific folder instead of deleting them outright. The folder to which a targeted file is to be moved can be specified in the Move to folder frame.

Notes:
  • If you choose the first option, make sure that the recycle bin on your system is enabled. Otherwise the files will be deleted immediately. Note that if you are working on a Windows 2000 or XP system, (de)activation of the recycle bin may be a matter for the System Administrator rather than individual users.

  • If a confirmation window appears when using the Move to folder option, the confirmation relates to the moving rather than the full deletion of the file.


The Move to folder frame

This frame is only accessible if the option Move to folder is chosen in the How to delete frame. Then, CloneSpy will not actually delete a targeted file according to the selection made in the Action frame in the Main window. Instead, the targeted file will be moved to a folder which can be specified in this frame.

The folder to which files are to be moved will be created on the drive or in the folder specified in the edit box. You may enter a different path to the edit box, or click on the Browse button to browse for a different drive or folder.

When the scanning process is started, CloneSpy will generate a specific folder name including the current date and time. For example, this folder name may look like:

  CS-2001.05.20-16.03

If you start the scanning process with the settings shown in the image above, CloneSpy will then move all targeted files to the following location:

  C:\Program files\CloneSpy\CS-2001.05.20-16.03\

This folder is generated when CloneSpy attempts to move the first file which is targeted. The way the folder will be structured depends on which of the two radio buttons is selected at the top of the frame:
  • Retain folder structure: When choosing this option, the full path of the file to be moved will be stored in the specified folder. Following the example above, assume that CloneSpy generated the following folder to which files are to be moved:

      C:\Program files\CloneSpy\CS-2001.05.20-16.03\

    Further, assume that a targeted file is located at:

      C:\Store\Images\RestrictDialog.bmp

    Then, the file will be moved to the following location:

      C:\Program files\CloneSpy\CS-2001.05.20-16.03\C\Store\Images\RestrictDialog.bmp

  • Just move files to folder: If you choose this option, all files targeted will just be moved directly to the specified folder without preserving the previous folder structure.
Notes:
  • Check that the drive where the specified folder is located has enough free space for the files to be moved.

  • If a file is going to be moved and the folder specified in this frame already contains a file with the same file name, CloneSpy will rename the file being moved according to the Windows rename functionality. This results in the addition of a preceding "Copy of" to the file name in the English version.


The Deletion of folders frame

Here you can select if an empty folder is to be deleted immediately after CloneSpy has removed the last file from that folder. To do this, just check the box in this frame.

This option ensures that folders which were empty before CloneSpy was started are not removed. This is because it is possible that you may wish or need to retain even empty folders.


The Shortcuts frame

In this frame you can select to replace a duplicate file by a shortcut to a corresponding retained file.

If you check this option, all files to be deleted are replaced by a shortcut. The shortcut will point to a corresponding retained duplicate file. The name of the shortcut will be the same as the name of the deleted file - including the extension plus the new extension .lnk. The new extension is added to the file name instead of replacing the old extension in order to decrease the likelihood of creating duplicate shortcut names.

This option is helpful if you want to free up disc space without losing information about the original content of the folders you scanned.

Notes:
  • If you use this option, you should restrict the scanning process to files larger than about 4 kbytes (see the Size of files frame). Otherwise replacing files will not result in saving disc space due to internal fragmentation and you could possibly replace shortcuts by shortcuts. However, CloneSpy never generates shortcuts for zero length files.

  • This option will not generate shortcuts when checking files against CSC-files. It simply makes no sense to create a shortcut pointing to a file which is described in a CSC-file and whose location may not be valid any more (because it is on a CD, for example).

  • A shortcut will only be generated if at least one of the duplicate files is retained.

  • If a shortcut with the same file name as a newly created one already exists, the existing shortcut is replaced by the new one.


The Files tab

This tab contains options which allow you to define by file masks whether a file is scanned or not. It consists of two frames:
  • the Restrict to files or file patterns frame
  • the Exclude files or file patterns frame


The Restrict to files or file patterns frame

This frame is for defining filters to identify the files that should be exclusively processed by CloneSpy. The functionality in this frame is the opposite of the Exclude files or file patterns frame where you can tell CloneSpy to exclude specific files from being scanned.

If you enable the check box on the upper left, only files matching the file masks entered to the list box below will be scanned. In order to modify the list you can use the four buttons at the bottom of the frame which have the following meaning:
  • Add mask: If you press this button, the Insert mask window is shown. There you can insert file names or file masks which are then added to the list box.

  • Clear list: Press this button to remove all entries from the list.

  • Load list: If you press this button you can import file masks from a CloneSpy restriction (*.csr) file to the list. All masks loaded will be added to the list box, so masks already existing in the list are not removed automatically.

  • Save list: This button allows you to store all entries in the list box to a CloneSpy restriction (*.csr) file.
Double-clicking on a file mask already inserted to the list box, allows you to modify the selected file mask. Pressing the Del key after highlighting a mask will remove it from the list.

For example, if you only want to search your photos for duplicates, you may insert the file masks *.bmp, *.gif, *.jpeg, and *.jpg to the list box as shown in the image above.

Note: The option presented in this frame cannot be used in conjunction with the Exclude files or file patterns option.


The Exclude files or file patterns frame

In this frame you can specify filters to define the files that should not be processed by CloneSpy. The functionality in this frame is the opposite of the Restrict to files or file patterns frame where you can tell CloneSpy to restrict a scan to specified files only.

If you enable the check box on the upper left, files matching the file masks entered to the list box below will not be scanned. In order to modify the list you can use the four buttons at the bottom of the frame which have the following meaning:
  • Add mask: If you press this button, the Insert mask window is shown. There you can insert file names or file masks which are then added to the list box.

  • Clear list: Press this button to remove all entries from the list.

  • Load list: If you press this button you can import file masks from a CloneSpy exclusion (*.cse) file to the list. All masks loaded will be added to the list box, so masks already existing in the list are not removed automatically.

  • Save list: This button allows you to store all entries in the list box to a CloneSpy exclusion (*.cse) file.
Double-clicking on a file mask already inserted to the list box, allows you to modify the selected file mask. Pressing the Del key after highlighting a mask will remove it from the list.

Note: The option presented in this frame cannot be used in conjunction with the Restrict to files or file patterns option.


The Folders tab

All options that deal with the folders of scanned files are presented in this tab. These options are located in the following two frames:
  • the Ignore folders frame
  • the Hidden folders frame


The Ignore folders frame

In this frame you can specify by mask, any folders that should not be scanned.

If the check box on the upper left is enabled, a folder and all its sub-folders will not be scanned if the name of the folder matches a folder mask in the list box on the right.

You can add new folder masks to the list box by selecting Add folder mask. Then, the Insert mask window appears. After confirming your input to that window, the mask you entered will be added to the list.

Single entries in the list can be deleted by pressing the Del key on your keyboard. The whole list can be cleared if you click the Clear list button on the left side.

Double-clicking on a folder mask already added to the list box allows you to modify the selected folder mask. For this reason, the Insert mask window appears again.


The Hidden folders frame

If you check the box in this frame, hidden folders will be ignored. This means that no files residing in a folder whose Hidden attribute is set will be acquired for scanning.

Notes:
  • If this option is selected, hidden folders will not be visible in the Add folder window.

  • This option is not applied to files aquired from a CSC-file as information about hidden folders are are not stored to CSC-files.


The Names tab

Option which refer to the file name of scanned files can be found in this tab. It consists of the following two frames:
  • the Override delete selection frame
  • the Comparison of file names frame


The Override delete selection frame

This frame is for revising an automatically delete selection made in the Action frame. Further, this option is only considered if you are searching for duplicates that do not need to have the same name. This means you have selected the item Duplicates in the Search for frame.

If you enable the check box on the upper left, you are allowed to enter file masks in the list box below. Here, a mask is an exception rule to an automatically delete option selected in the Action frame.

The four buttons on the right have the following meaning:
  • Add mask: Click this button in order to enter a new file mask to the list box. Therefore, the Insert mask window is displayed.

  • Clear list: If you click this button, all items are removed from the list box.

  • Load list: Use this button to import file masks from a CloneSpy override (*.cso) file. Loading an override file adds all masks from the file to the list. This means that existing items already in the list are not deleted.

  • Save list: This button is for saving all items in the list box to a CloneSpy override (*.cso) file. Saving the list allows you to generate various override files for different scans.
Double-clicking on a file mask already added to the list box allows you to modify the selected file mask. Pressing the Del key on your keyboard removes a highlighted item from the list.

If you start the CloneSpy scanning process with this frame activated, and CloneSpy detects duplicate files with different file names, the files that should be deleted according to the selection made in the Action frame are checked against all file masks in the list box. If one of these files matches a file mask, it will not be deleted (or moved; cf. the How to delete frame). Instead all other duplicates including the file that normally would be retained will be deleted.

Example

Assume you decide in the Search for frame that you only want to search for duplicates. Then, you choose the Both Pools option in the Mode frame, enter some drives or folders to both the Pool frames, and specify in the Action frame only to delete in Pool 2. Now you enter two file masks to this frame: *gold* and project*. Then you start the scanning process with the Start scanning button. CloneSpy finds the following duplicates:

Test.txt in Pool 1, and
ProjectDocumentation.txt in Pool 2.

Because the second file name matches a file mask in the override list of this frame (project*), the first file will be deleted, even though the selection in the Action frame is set to the contrary. If the file in Pool 2 would also be overridden because a corresponding mask exists, the override option would be ignored and therefore the file in Pool 2 would be deleted.

It is important to note here that the comparison is affected by the selection made in the Comparison of file names frame. If the option to compare case sensitive file names is made there then in this example the file Test.txt would not be overridden, because the first letter in the mask project* is lower case and the first letter in the file name ProjectDocumentation.txt is upper case.


The Comparison of file names frame

In this frame you can specify whether all file name comparisons done by CloneSpy are case insensitive or case sensitive.

Assume that you select an option in the Search for frame in the Main window which examines the name of the files scanned. Then, assume that while scanning two files with the following names are compared to each other:

  Information.txt
  InFoRmAtIoN.tXt

If the case insensitive option is selected, the two file names are viewed as equal, otherwise not. Note, that Windows normally considers these file names as equal even though the case is different. Therefore, the case insensitive option is the default option.

It is also important to note is that the options in the Exclude files or file patterns frame and in the Restrict to files or file patterns frame are affected, too. Assume that you restrict all scanned files in the Restrict to files or file patterns frame to *.txt files only. Then, if the case sensitive option is selected, files are not considered if their extensions are TXT or Txt, for example. Moreover, the Override delete selection frame is also affected by the case selection.


The Time + Size tab

This tab contains options about time and size of scanned files. These options are divided into four frames:
  • the Time of files frame
  • the Size of files frame
  • the Size of same-name files frame
  • the Zero length files frame


The Time of files frame

In this frame you can decide the date and time limits within which a file will be scanned.

The date and time refer to the last modification of the corresponding file. If you select both check boxes, files are only scanned if they are newer than the first date and time and older than the second date and time.


The Size of files frame

In this frame you can select the size limits within which a file will be scanned.

If you check both check boxes, files must be larger than the size selected in the first box and smaller than the size selected in the second box.

Here 1 kbyte is to be understood as 1024 bytes, 1 Mbyte is the same as 1024 kbytes and so on.


The Size of same-name files frame

The settings in this frame are only used in the scanning process if you select the option Same name + (approx.) same size in the Search for frame in the Main window.

If the selection is set to 0 bytes files are detected if they have the same name and the same size. Otherwise the difference between the size of the files must be lower than or equal to the selected value.

Note: Assume that the allowed difference between the size of files is set to 10 bytes. Further, assume that three files are found in the scanning process which have the same name. The three files are 100 bytes, 110 bytes, and 120 bytes, respectively. This combination means that all three files will be interpreted as equal, even though the difference between the first and the third file exceeds the chosen allowed difference of 10 bytes.


The Zero length files frame

In this frame you can choose how zero length files are handled by CloneSpy. Zero length files are files that have a size of zero bytes. They exist, but don't have any content.

This frame offers three options:
  1. Ignore: If this button is selected, CloneSpy will not process zero length files. Even when generating CSC-files (see the Pool frames in the Main window for details) zero length files are ignored and therefore not written to the CSC-file.

  2. Examine: If you select this option, CloneSpy will display all zero byte files found in the scanning process. For information about the presentation of these files to the user see the description of the Zero byte files window. When generating a CSC-file select this option if you want to store information about all zero byte files found to the CSC-file.

  3. Delete: Press this button if you want CloneSpy to delete all scanned zero length files. Use this option with care, as it is occasionally possible that a program has need to write data to a zero length file, and may behave improperly if you remove it. No files are deleted while generating CSC-files.
Note: Even if you chose to generate shortcuts for deleted files (see the Shortcuts frame in the Options window), no shortcuts will be generated for any deleted zero length file.


The Logging tab

This tab contains all options about logging. These options are presented in two frames:
  • the Logging properties frame
  • the Log file frame


The Logging properties frame

This frame allows you to keep a record (log) of specific file operations done by CloneSpy.

If the Enable check box in the upper left-hand corner is activated at least one line of information for every scan started is written to a log file which can be specified in the Log file frame. This information includes the time when the corresponding scan was started, what kind of files CloneSpy was searching for, and how they where handled. The following options are for adding additional information to the log file:
  • Log deleted files: Check this option if you want CloneSpy to store information about every deleted (or moved; cf. the How to delete frame) file to the log file. The size and the path of each processed file will be presented in a single line in the log file.

  • Log retained files: If you check this box CloneSpy logs all files that are retained. Note that this does not mean that all scanned non duplicate files are listed in the log file. A file is only listed as a retained file, if there was at least one corresponding duplicate file that was actually deleted.

    If you enable this option in combination with the option Log deleted files the log file may get a bit complex. To explain the structure, assume that there are seven duplicate files which are all the same. Also, assume that three of them are deleted and the other four are retained. Then, in the log file there will be a block of information about the duplicate files (in our example three) that were deleted, possibly mixed up with some lines containing names of deleted folders or information about file access errors which may have occurred (see below). After this, there will be a block of the corresponding duplicate files (in our case four) that were retained.

    Enable this option in combination with automatic deletion (see the Action frame in the Main window) to understand why, after scanning, certain files were deleted.

  • Log deleted folders: Check this option if you want CloneSpy to log every deleted folder. For more information about the deletion of folders consult the description of the Deletion of folders frame in the Options window.

  • Log errors: If you enable this option CloneSpy logs errors which may occur while accessing files (e.g. if you do not have the permission to scan a specific file, etc.). File errors are logged even if you disable corresponding notifications in the Ignore errors frame) or if you skip further warnings in a displayed notification window.


The Log file frame

In this frame you can specify the file which CloneSpy will use for logging. The controls in this frame will only be accessible if you enable the logging option in the Logging properties frame.

All data specified in the Logging properties frame will be written into the log file indicated in the edit box at the bottom of the frame. If you want CloneSpy to use a different file to store the data, modify the path in the edit box, or specify another file by clicking the Browse button.

If the specified log file does not exist, it will be created when the scan is started. If the log file already exists, the three radio buttons at the top of the frame allow for three options:
  • Append data: If you choose this option the information about a scan will be added at the end of the existing log file. Remember that over a period of time quite large files may be generated if you select this option.

  • Replace file: If you select this button the existing file will be deleted and a new one created.

  • Make new file: This option will force CloneSpy to generate a new log file. The new log file will have the same name as entered in the edit box followed by an underscore character and a number. Assume that the file CloneSpy.log is chosen and that it already exists. In this case the program will try to create a log file which has the name CloneSpy_2.log. If this file also exists, CloneSpy_3.log is tested and so on.


The Report tab

This tab contains two frames relating to the way in which information is presented to the user:
  • the Presentation of equal files frame
  • the Ignore errors frame


The Presentation of equal files frame

This frame is for specifying when and how to display duplicates to the user if the option Ask user is selected in the Action frame of the Main window.

The main selection in this frame allows you to specify when duplicates should be presented to the user:
  • Immediately display equal files: If you select this option CloneSpy will present duplicates immediately after detecting them in the Single duplicates window.

  • Wait until all files are scanned: This option enables CloneSpy to show duplicates only when the entire scan is finished. Here you can also choose which one of two Result presentation windows is used in order to present duplicates which have been found:

    • display all equal files individually: All sets of duplicates are shown one after another by using the Single duplicates window.

    • display all equal files together in a list: All sets of duplicate files are presented together in one list which is part of the All duplicates window.


The Ignore errors frame

In this frame you can disable file access error windows that might be displayed while scanning.

Windows locks some files for exclusive access. When CloneSpy tries to read such a file, a file access error is displayed. Normally, the corresponding display windows have an Ignore and an Ignore all button. If you press the Ignore button only the current attempt at file access is skipped. In contrast, the Ignore all button causes CloneSpy to ignore all further file access errors in the current scanning process.

If you want to prevent CloneSpy from reporting file access errors right away from the beginning of a scan then you can do it in this frame. The options in this frame also allow you to differentiate between file access errors in the different scanning phases. Check the corresponding boxes in order to ignore errors
  • while generating checksums for files,
  • while scanning for equal files, or
  • while deleting files
Selecting all options in this frame makes unattended operation of CloneSpy possible until duplicate files are displayed to the user. Windows may present several files which it won't let you open, because they are used constantly by the system.

Note: When you check at least one box in this frame, you should activate the option Log errors in the Logging properties frame. Then, you have the possibility of viewing them after a scan is finished.


The Export tab

If you want CloneSpy not to delete any file but simply to export the result of a scan to a batch or a list file, this tab offers corresponding options in two frames:
  • the Batch file properties frame
  • the Export list properties frame


The Batch file properties frame

This frame is for specifying a batch file which is used if you select the option Defer deletion to batch file in the On automatic deletion frame in the Main window. Moreover, the structure of the batch file can be defined in this frame.

The radio buttons Append data, Replace file, and Make new file have the same functionality as the buttons in the Log file frame.

In the File edit box you can specify the batch file which is used to export data about targeted files. You may use the Browse button for selecting a file from your system. The structure which will be created in the specified batch file has to be defined in the Format edit box. For every targeted file one line corresponding to the format will be written to the batch file. In order to include information about handled files please use the patterns from the following table. All other characters entered to the Format line will simply be written to the batch file.

 | Files targeted for deletion | Corresponding file to be retained
Size: | %ds | %rs
Name: | %nd | %rn
Path: | %dp | %rp
Folder: | %df | %rf
Time: | %dt | %rt
Attributes: | %da | %ra

For more information on the individual patterns please refer to the Export list properties frame.

Notes:
  • The option to defer file deletion to a batch file is only possible if you select an Automatically delete option in the Action frame in the Main window. This ensures that exactly one file of a set of equal files is chosen to be the one which is retained while all other files are scheduled for deletion or another file operation, respectively.

  • Zero byte files are not written to the specified batch file, because they are handled as defined in the Zero length files frame.


The Export list properties frame

In this frame you can specify the file which is used if you select the option Export a list of all equal files in the Action frame in the Main window. You can also specify how the list file should be built.

The radio buttons Append data, Replace file, and Make new file have the same functionality as the buttons in the Log file frame.

The file to which the list of all equal files found is exported can be specified directly in the File edit box. You can also use the Browse button in order to select a file from your system.

For every file in a set of equal files a line corresponding to the text entered to the Format edit box is written to the list file. As usual, the term equal refers to selection made in the Search for frame. Different sets of equal files are separated in the list file by an empty line. In order to insert file data of a corresponding file to the lines written to the list file enter the patterns from the following table to the Format edit box. All other characters will be written to the list file as they are entered in the Format field.

Pattern | Description
%s | the file size in bytes
%n | the name of the file
%p | the complete file path
%f | the folder path where the file is located
%t | time/date when the file was last modified
%a | an attribute string containing the letters "RHSA" if read-only, hidden, system file, and archive bits are set. If an attribute is not set for the file then the corresponding letter is substituted by an "-"


The Priority tab

This tab contains only one option concerning the priority of the scanning process presented in the following frame:
  • the Scanning priority frame


The Scanning priority frame

In this frame you can select at which priority CloneSpy runs when it searches for equal files. The priority values which refer to the priority classes selectable from the drop down list can be found in the following table.

Priority class | Priority value
highest priority | +2
higher priority | +1
normal priority | 0
lower priority | -1
lowest priority | -2
idle priority | -15

Notes:
  • If you want to run CloneSpy in parallel with other programs then please make sure that you read the Important Note before doing so.

  • The scanning process mainly relies on hard drive access. Therefore, if you want to run other programs in parallel which frequently access your hard drive, you should better choose the idle priority option. Otherwise the performance of those programs may be affected.

  • If you run the scanning process at idle priority then updating of the program's window can be very slow, especially if the processor operates at full capacity due to other programs running in parallel. Aborting the process can then also take a few seconds.


The Insert mask window

This window appears if you click the Browse button in one of the following frames of the Options window:
  • the Restrict to files or file patterns frame
  • the Exclude files or file patterns frame
  • the Ignore folders frame
  • the Override delete selection frame
The window elements

Depending on context this window will ask you whether to insert a file mask or a folder mask. You can insert the corresponding mask directly to the edit box. If you click the Browse button when asked for a file mask you can select a file name from the file dialog which appears. When you are asked for a folder mask, a directory tree is presented after clicking the Browse button from which you can select a folder name.

As indicated in the dialog box, you may include the wildcard characters * and ? in the mask you want to create. As usual in Windows, * stands for an arbitrary string of characters which can also be empty, while ? stands for just one arbitrary character.


The Automation window

In the upper frame of this window you can specify if a settings file should be loaded when the program starts. In the lower frame you can specify if all settings should be saved on program exit. The settings include the parameters for all controls in the Main window and in the Options window.

In both cases you can enter file names directly into the edit boxes or search for a settings file by clicking on the browse button.


The View CSC-file window

This window displays the contents of a selected CloneSpy checksum file. In order to view the CSC-file, double click on it after inserting it in the Checksum files frame or by selecting View CSC-File in the file menu of the Main window.

The window elements

In the topmost frame, the CSC file data frame, information about the selected CSC-file is presented. This includes the file name of the CSC-file and the time and date of its last modification. Normally, the time and date refer to the creation of the checksum file.

The tree view on the left side of the window displays the folders together with the files that were included in the selected CSC-file. It is important to note that the displayed locations refer to the original locations of the files when the checksum file was recorded. Remember, when viewing a CSC-file, that the original files may have been subsequently moved or removed.

The tree view has to be built from the selected CSC-file. This process can take some time. The Status frame on the right displays the building process. When finished, the number of files stored in the CSC-file is displayed.

You may select a file in the tree view by clicking on it. Then, the data of this file which is stored in the CSC-file will be presented in the Selected file data frame on the right.

Press the Close button to close this window and return to the main window.


Result presentation windows

The windows presented in this frame will only appear in the following circumstances:
  1. The option Ask user is selected in the Action frame of the Main window.

  2. The option Examine is chosen in the Zero length files frame.

Altogether there are three result windows:
  • the Single duplicates window
  • the All duplicates window
  • the Zero byte files window


The Single duplicates window

This window is presented as a result of a scanning process if the option Wait until all files are scanned and display all equal files individually or the option Immediately display found equal files was selected in the Presentation of equal files frame before the scan was started. Of course, the option Ask user has to be selected in the Action frame in the Main window, also.

The window elements

In the first line on the left the number and the type of equal files are displayed. On the right side of this line a legend is presented in some cases. This happens if you have chosen one of the last three options in the Mode frame in the Main window.

The second line shows data that is equal for all files displayed in the list box below. Depending on the selection made in the Search for frame in the Main window, this will show the file size, the file name or both.

The list box

In the center of the window the list of all equal files is presented. Depending on the selection made in the Search for frame in the Main window, the number of columns is three or four.

The header of the list can be clicked to sort the list items in every category corresponding to the selected column.

At the start of each line the status of the displayed file is shown. A file can be marked or not. If files from a CSC-file are presented, there is a prohibition sign in front of the corresponding lines. Of course, these files cannot be marked because they are not removable.

In order to mark a file for deletion a file row has to be double clicked. You can also mark a highlighted file in the list by pressing the Space bar on your keyboard. In order to unmark a file double click the file or press Space again.

Preselect files

In the lower left corner of the window you can select which files in the list box above should be marked. The options available in the drop down list depend on the selections made in the Mode frame or in the Search for frame in the Main window. If you delete the marked files and the window reappears to present new duplicates, files will already be marked according to the previously selected option. For more information on the items found in the drop down list please refer to the description of the Action frame in the Main window.

The buttons

The six buttons in the lower right corner are explained in the following:
  • Invert file selection: If you click this button, all marked files will change to not marked and vice versa.

  • Execute selected file: This button allows you to execute a highlighted file in the list with the program that is associated with this file type in Windows.

  • Explore folder of file: Click this button to explore the folder where the highlighted file in the list is located.

  • Stop scanning: In order to cancel the scanning process, click this button.

  • Skip all displayed files: Press this button to ignore all files (even if marked) and to move on to the next comparison. This option has the same effect as selecting Mark none and pressing Delete all marked files. It is included to facilitate the process of comparing a large number of files, by saving the need to switch between one of the other mark options and Mark none.

  • Delete all marked files: If you press this button, CloneSpy handles all files marked in the list box as selected in the How to delete frame in the Options window. Then, CloneSpy continues with the scanning process.


The All duplicates window

This window is shown as a result of a scanning process if the option Wait until all files are scanned and display all equal files together in a list was selected in the Presentation of equal files frame before a scan is started. Of course, the option Ask user has also to be selected in the Action frame in the Main window.

The window elements

In the first line on the left the entire number of all equal files and the number of corresponding categories are shown. All files that are equal to each other are within the same category. On the right side of this line a legend is presented in some cases. This happens if you have chosen one of the last three options in the Mode frame in the Main window.

The list box

The list in the center of the window displays all duplicates that were found during the scanning process. The list shows two different types of entries: the file rows which show information about the equal files found and the corresponding category rows.

Each category row shows data that is equal for all files displayed in the rows below. Depending on the selection made in the Search for frame in the Main window, this will show the file size, the file name or both.

The list header can be clicked in order to sort the list items inside each category corresponding to the selected column.

At the start of every non-category line the status of the displayed file is shown. A file can be marked or not. If files from a CSC-file are shown, there is a prohibition sign in front of the corresponding lines. Of course, these files cannot be marked because they are not removable.

In order to mark a file for deletion a file row has to be double clicked. You can also mark a highlighted file in the list by pressing the Space bar on your keyboard. To unmark a file, double click the file or press Space again. Double clicking or pressing Space on a category will close an open category and open a closed one. Pressing the Del key on a category row will remove the whole category from the list while executing no operation on the files contained in it.

The Open/Close categories frame

In this frame the number of all open and closed categories are shown. At the beginning all categories are open. Categories can be closed in order to prevent CloneSpy from applying specific operations to the corresponding files. See below for more information. In the drop down list below you can select which categories you want to open or close, respectively. In order to apply the selected operation to the list, press the Execute selection button at the bottom of the frame.

The Process also closed categories option

This option affects all controls which are below the frame that surrounds it. These are the Open/Close categories frame, the Invert file selection button, and the Delete all marked files button. If this option is activated these three controls will also affect files in categories which may be closed.

The Mark files frame

Here you can specify which files in the list are to be marked automatically. Select in the drop down list the kind of files you want to mark. Then, press the button Execute selection to apply the operation to the file list. The options available in the drop down list depend on the selections made in the Mode frame or in the Search for frame in the Main window. For more information on the items found in the drop down list please refer to the description of the Action frame in the Main window.

The remaining buttons

In addition to the two Execute selection buttons which are described above, another five buttons in the lower right corner of the window are shown:
  • Invert file selection: If you click this button, all marked files in the list will change to unmarked and vice versa.
  • Delete all marked files: If you click this button all files marked in the list are handled as selected in the How to delete frame in the Options window. Subsequently, all the categories in which at least one file was removed are removed from the list. This is because CloneSpy assumes that you handle whole categories and that you want to keep the remaining unmarked files in these categories.
  • Close window: If you click this button this window will be closed and the scan is finished.
  • Execute selected file: This button allows you to execute the selected file in the list with the program that is associated with this file type in Windows.
  • Explore folder of file: Click this button to explore the folder where a selected file is located.


The Zero byte files window

This frame will appear while scanning only if the option Examine is selected in the Zero length files frame and of course only if at least one file which is zero bytes long is found.

The window elements

In the first line on the left the number of zero byte files found is displayed. On the right side of this line a legend is presented in some cases. This happens if you have chosen one of the last three options in the Mode frame in the Main window.

The list box

In the center of the window the list of all zero length files is presented. The header of the list can be clicked to sort the list items in every category corresponding to the selected column.

At the start of each line the status of the displayed file is shown. A file can be marked or not. If files from a CSC-file are presented, there is a prohibition sign in front of the corresponding lines. Of course, these files cannot be marked because they are not removable.

In order to mark a file for deletion a file row has to be double clicked. You can also mark a highlighted file in the list by pressing the Space bar on your keyboard. In order to unmark a file double click the file or press Space again.

The buttons

The five buttons on the bottom of the window are:
  • Invert file selection: If you click this button, all marked files will change to not marked and vice versa.

  • Explore folder of file: Click this button to explore the folder where the highlighted file in the list is located.

  • Stop scanning: In order to cancel the whole scanning process, click this button.

  • Skip all displayed files: Press this button to ignore all files (even if marked) and to continue with the scan.

  • Delete all marked files: If you press this button, CloneSpy handles all files marked in the list box as selected in the How to delete frame in the Options window. Then, CloneSpy continues with the scanning process.